# Looking for ParMETIS

find_path(PARMETIS_INCLUDE_DIR parmetis.h
  PATH_SUFFIX include parmetis $ENV{PARMETIS_INCDIR})

if(EXISTS "${PARMETIS_INCLUDE_DIR}/parmetis.h")
  message(STATUS "Found parmetis.h in ${PARMETIS_INCLUDE_DIR}")
  find_library(LIB_PARMETIS parmetis $ENV{PARMETIS_LIBDIR})
  if("${LIB_PARMETIS}" STREQUAL "LIB_PARMETIS-NOTFOUND")
    message(WARNING "** Could not find parmetis library.\n** Is PARMETIS_LIBDIR correctly set (Actual: \"$ENV{PARMETIS_LIBDIR}\")?")
  endif()
  find_library(LIB_METIS metis $ENV{METIS_LIBDIR})
  if("${LIB_PARMETIS}" STREQUAL "LIB_METIS-NOTFOUND")
    message(WARNING "** Could not find metis library.\n** Is METIS_LIBDIR correctly set (Actual: \"$ENV{METIS_LIBDIR}\")?")
  endif()
  find_path(METIS_INCLUDE_DIR metis.h $ENV{METIS_INCDIR})
  if(EXISTS "${METIS_INCLUDE_DIR}/metis.h")
    message(STATUS "Found metis.h in ${METIS_INCLUDE_DIR}")
    set(PARMETIS_LIBRARIES ${LIB_PARMETIS})
    set(METIS_LIBRARIES  ${LIB_METIS})
    message(STATUS "Found parmetis/metis libraries ${PARMETIS_LIBRARIES}")
    else()
      message(WARNING "** Could not find metis.h.\n** Is METIS_INCDIR correctly set (Actual: \"$ENV{METIS_INCDIR}\")?")
  endif()
else()
  message(WARNING "** Could not find parmetis.h.\n** Is PARMETIS_INCDIR correctly set (Actual: \"$ENV{PARMETIS_INCDIR}\")?")
endif()

mark_as_advanced(PARMETIS_INCLUDE_DIR PARMETIS_LIBRARIES)
mark_as_advanced(METIS_INCLUDE_DIR METIS_LIBRARIES)
